/*
 * assemble-goldcome-toc
 * Copyright (c) 2012 GoldCome, contributors.
 * Licensed under the MIT license.
 */

var options = {
    stage: 'render:post:page'
};

//加载依赖模块
var cheerio = require('cheerio');
var hljs = require('highlight.js');

/**
 * Highlight Plugin
 * @param  {Object}   params
 * @param  {Function} callback
 */
module.exports = function (params, callback) {
    'use strict';

    var content = params.content;

    var opts = params.assemble.options;
    opts.highlight = opts.highlight || {};

    // 指定要highlight的容器ID，默认是全局
    var boxid = '#' + (opts.highlight.boxid || '');

    // 加载当前页内容
    var $ = cheerio.load(content);

    // 构建选择器函数，实际上是字符串拼接
    // 无参数，返回构建结果
    function buildSelector() {
        var result;
        if (boxid === '#') {
            result = 'code';
        }
        else {
            result = boxid + ' ' + 'code';
        }
        //console.log(result);
        return result;
    }

    var code = $(buildSelector());

    //遍历code代码内容处理并替换
    code.map(function (i, e) {
        var result = hljs.highlightAuto($(e).text()).value;
        //console.log(result);
        $(e).html(result);
    });

    params.content = $.html();
    callback();
};

module.exports.options = options;